Ring[] rings;
int numRings = 50;
int currentRing = 0;

void setup() {
  frameRate(30);
  background(0);
  size(800, 600);
  smooth();
  rings = new Ring[numRings];
  for (int i=0; i < numRings; i++) {
    rings[i] = new Ring();
  }
}

void draw() {
  fill(0, 25);
  rect(0, 0, width, height);
  if (frameCount % 25 == 0) {
    rings[currentRing].start(width/2, height/2);
    currentRing++;
    if (currentRing >= numRings) {
      currentRing = 0;
    }
  }
  for (int i=0; i < numRings; i++) {
    rings[i].grow();
    rings[i].display();
  }
}

void mousePressed() {
  rings[currentRing].start(mouseX, mouseY);
  currentRing++;
  if (currentRing >= numRings) {
    currentRing = 0;
  }
}

void mouseDragged() {
  if (frameCount % 5 == 0) {
    rings[currentRing].start(mouseX, mouseY);
    currentRing++;
    if (currentRing >= numRings) {
      currentRing = 0;
    }
  }
}
// Define the Ring class. Notice that no constructor is
// needed because the start method is used to initiate
// the objects behavior.
class Ring {
  float x, y, diameter;
  boolean on = false;
  int r = 0;
  int g = 0;
  int b = 0;
  void start(float xpos, float ypos) {
    x = xpos;
    y = ypos;
    r = floor((currentRing/(numRings-1))*255);
    g = 255-abs((floor(sin(currentRing/10)*255)));
    //println("g: "+g);
    b = 255-floor((currentRing/(numRings-1))*255);
    on = true;
    diameter = 600;
  }
  void grow() {
    if (on) {
      diameter -= 0.5;
      if (diameter < 1) {
        on = false;
      }
    }
  }
  void display() {
    if (on) {
      noFill();
      strokeWeight(4);
      stroke(r,g,b,153);
      ellipse(x, y, diameter, diameter);
    }
  }
}

